	import * as THREE from 'three';


	// PS rack
	export function rps(width=800, height=2500, depth=600) {
		const rps_rackObject = new THREE.Object3D();
		const psObject = new THREE.Object3D();
	
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		const materialVeryGreyDark= new THREE.MeshLambertMaterial({color: 0x242424});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x17fc03});
		const whitematerial = new THREE.MeshLambertMaterial({color: 0xffffff});
		const redmaterial = new THREE.MeshLambertMaterial({color: 0xff0000});
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const screenmaterial = new THREE.MeshLambertMaterial({color: 0xdeebff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		
		// rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		rrmesh.position.set( 0, 0 , 0);
		rps_rackObject.add(rrmesh);		
		
		//edge le	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -285);
		rps_rackObject.add(llemesh);
		
		//edge re		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-550);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 265);
		rps_rackObject.add(lremesh);		

		//edge ue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , -7);
		rps_rackObject.add(luemesh);		

		//edge de		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , -7);
		rps_rackObject.add(ldemesh);				

		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 500);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -15);
		rps_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 500);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -15);
		rps_rackObject.add(Rtargetmesh);				
	
		// START PS base RED 
		const basered = new THREE.BoxGeometry(10, 30, 110);
		const baseredmesh = new THREE.Mesh(basered, redmaterial);
		baseredmesh.position.set( -401, 1100 , -170);
		psObject.add(baseredmesh);
		
		//  PS base BLUE 
		const baseblue = new THREE.BoxGeometry(10, 180, 110);
		const basebluemesh = new THREE.Mesh(baseblue, bluematerial);
		basebluemesh.position.set( -401, 995 , -170);
		psObject.add(basebluemesh);			

		//  PS base SILVER 
		const basesilver = new THREE.BoxGeometry(10, 150, 500);
		const basesilvermesh = new THREE.Mesh(basesilver, silvermaterial);
		basesilvermesh.position.set( -401, -300 , 0);
		rps_rackObject.add(basesilvermesh);			
		
		rps_rackObject.add(psObject);
		
		//CLONE PS 

		const psA2 = psObject.clone();
		psA2.position.set( 0, 0 , 120);
		rps_rackObject.add(psA2);
		
		const psA3 = psObject.clone();
		psA3.position.set( 0, 0 , 240);
		rps_rackObject.add(psA3);	
		
		const psB1 = psObject.clone();
		psB1.position.set( 0, -220 , 0);
		rps_rackObject.add(psB1);
		
		const psB2 = psObject.clone();
		psB2.position.set( 0, -220 , 120);
		rps_rackObject.add(psB2);
		
		const psB3 = psObject.clone();
		psB3.position.set( 0, -220 , 240);
		rps_rackObject.add(psB3);
		
		const psC1 = psObject.clone();
		psC1.position.set( 0, -440 , 0);
		rps_rackObject.add(psC1);
		
		const psC2 = psObject.clone();
		psC2.position.set( 0, -440 , 120);
		rps_rackObject.add(psC2);
		
		const psC3 = psObject.clone();
		psC3.position.set( 0, -440 , 240);
		rps_rackObject.add(psC3);
		
		const psD1 = psObject.clone();
		psD1.position.set( 0, -660 , 0);
		rps_rackObject.add(psD1);
		
		const psD2 = psObject.clone();
		psD2.position.set( 0, -660 , 120);
		rps_rackObject.add(psD2);
		
		const psD3 = psObject.clone();
		psD3.position.set( 0, -660 , 240);
		rps_rackObject.add(psD3);	
		
		const psE1 = psObject.clone();
		psE1.position.set( 0, -880 , 0);
		rps_rackObject.add(psE1);
		
		const psE2 = psObject.clone();
		psE2.position.set( 0, -880 , 120);
		rps_rackObject.add(psE2);
		
		const psE3 = psObject.clone();
		psE3.position.set( 0, -880 , 240);
		rps_rackObject.add(psE3);		
		
		return rps_rackObject;
	}
